/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of BSONbooleanAdapter.xxs. Do not edit this file, edit BSONbooleanAdapter.xxs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "/builddir/build/BUILD/polymake-4.4/lib/core/src/perl/BSONbooleanAdapter.xxs"
/* Copyright (c) 1997-2021
   Ewgenij Gawrilow, Michael Joswig, and the polymake team
   Technische Universität Berlin, Germany
   https://polymake.org

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
*/

#include "polymake/perl/Ext.h"

namespace {

using XSUB_t = void (*)(pTHX_ CV*);

SV *true_sv = nullptr, *false_sv = nullptr;
CV *encode_cv = nullptr, *decode_cv = nullptr;
XSUB_t encode_xsub = nullptr, decode_xsub = nullptr;
HV *BSON_Doc_stash = nullptr, *Tie_IxHash_stash = nullptr;
SV *boolean_pkg = nullptr;

void replace_booleans(pTHX_ SV* sv);

void replace_booleans(pTHX_ AV* av, SSize_t start = 0, SSize_t step = 1)
{
   const SSize_t last = AvFILLp(av);
   if (last >= 0) {
      for (SV **svp = AvARRAY(av) + start, **lastp = svp + last;  svp <= lastp;  svp += step) {
         SV* val = *svp;
         if (val && SvOK(val))
            replace_booleans(aTHX_ val);
      }
   }
}

void replace_booleans(pTHX_ HV* hv)
{
   if (hv_iterinit(hv)) {
      while (HE* he = hv_iternext(hv)) {
         SV* val = HeVAL(he);
         if (SvOK(val))
            replace_booleans(aTHX_ val);
      }
   }
}

void replace_booleans(pTHX_ SV* sv)
{
   if (SvROK(sv)) {
      sv = SvRV(sv);
      if (SvOBJECT(sv)) {
         if (SvTYPE(sv) == SVt_PVAV) {
            if (SvSTASH(sv) == Tie_IxHash_stash)
               replace_booleans(aTHX_ (AV*)SvRV(AvARRAY(sv)[2]));
            else if (SvSTASH(sv) == BSON_Doc_stash)
               replace_booleans(aTHX_ (AV*)sv, 1, 2);
         }
      } else if (SvGMAGICAL(sv) && SvTYPE(sv) == SVt_PVHV) {
         if (MAGIC* mg = mg_find(sv, PERL_MAGIC_tied)) {
            SV* tied = mg->mg_obj;
            if (tied && SvROK(tied) && (tied = SvRV(tied), SvOBJECT(tied) && SvSTASH(tied) == Tie_IxHash_stash))
               replace_booleans(aTHX_ (AV*)SvRV(AvARRAY(tied)[2]));
         }
      } else if (SvTYPE(sv) == SVt_PVAV) {
         replace_booleans(aTHX_ (AV*)sv);
      } else if (SvTYPE(sv) == SVt_PVHV) {
         replace_booleans(aTHX_ (HV*)sv);
      }
   } else if (pm::perl::glue::is_boolean_value(aTHX_ sv)) {
      pm::perl::ops::localize_scalar(aTHX_ sv, SvTRUE(sv) ? true_sv : false_sv);
   }
}

OP* intercept_pp_ref(pTHX)
{
   dSP; dTOPss;
   if (!SvROK(sv)) {
      if (pm::perl::glue::is_boolean_value(aTHX_ sv))
         SETs(boolean_pkg);
      else
         SETs(&PL_sv_no);
      return NORMAL;
   }
   return Perl_pp_ref(aTHX);
}

void replace_ref(pTHX_ OP* o)
{
   if (o->op_type == OP_REF) {
      o->op_ppaddr = &intercept_pp_ref;
   } else if (o->op_flags & OPf_KIDS) {
      OP* kid = cUNOPo->op_first;
      do replace_ref(aTHX_ kid); while ((kid = OpSIBLING(kid)));
   }
}

}

#line 117 "/builddir/build/BUILD/polymake-4.4/build.i386/perlx/5.34.0/i386-linux-thread-multi-64int/BSONbooleanAdapter.cc"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 261 "/builddir/build/BUILD/polymake-4.4/build.i386/perlx/5.34.0/i386-linux-thread-multi-64int/BSONbooleanAdapter.cc"

XS_EUPXS(XS_Polymake__BSONbooleanAdapter__encode_bson); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Polymake__BSONbooleanAdapter__encode_bson)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "doc, options");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	doc = ST(0)
;
	SV *	options = ST(1)
;
#line 113 "/builddir/build/BUILD/polymake-4.4/lib/core/src/perl/BSONbooleanAdapter.xxs"
{
   (void)options;  // unused
   PUSHMARK(SP);
   SP += 2;
   PUTBACK;
   replace_booleans(aTHX_ doc);
   encode_xsub(aTHX_ encode_cv);
   SPAGAIN;
}
#line 286 "/builddir/build/BUILD/polymake-4.4/build.i386/perlx/5.34.0/i386-linux-thread-multi-64int/BSONbooleanAdapter.cc"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Polymake__BSONbooleanAdapter__decode_bson); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Polymake__BSONbooleanAdapter__decode_bson)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "msg, options");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	msg = ST(0)
;
	SV *	options = ST(1)
;
#line 125 "/builddir/build/BUILD/polymake-4.4/lib/core/src/perl/BSONbooleanAdapter.xxs"
{
   (void)msg; (void)options;  // unused
   PUSHMARK(SP);
   SP += 2;
   PUTBACK;
   pm::perl::ops::localize_scalar(aTHX_ true_sv, &PL_sv_yes);
   pm::perl::ops::localize_scalar(aTHX_ false_sv, &PL_sv_no);
   decode_xsub(aTHX_ decode_cv);
   SPAGAIN;
}
#line 317 "/builddir/build/BUILD/polymake-4.4/build.i386/perlx/5.34.0/i386-linux-thread-multi-64int/BSONbooleanAdapter.cc"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Polymake__BSONbooleanAdapter_prepare_XS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Polymake__BSONbooleanAdapter_prepare_XS)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "encode_subref, decode_subref, true_val, false_val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	encode_subref = ST(0)
;
	SV *	decode_subref = ST(1)
;
	SV *	true_val = ST(2)
;
	SV *	false_val = ST(3)
;
#line 138 "/builddir/build/BUILD/polymake-4.4/lib/core/src/perl/BSONbooleanAdapter.xxs"
{
   if (encode_cv)
      croak( "BSONbooleanAdapter::prepare called repeatedly - should only be invoked from the static part of its perl module" );
   if (!(SvROK(encode_subref) && SvTYPE(SvRV(encode_subref)) == SVt_PVCV &&
         (encode_cv = (CV*)SvRV(encode_subref), CvISXSUB(encode_cv))))
      croak( "_encode_bson is not an XSUB" );
   if (!(SvROK(decode_subref) && SvTYPE(SvRV(decode_subref)) == SVt_PVCV &&
         (decode_cv = (CV*)SvRV(decode_subref), CvISXSUB(decode_cv))))
      croak( "_decode_bson is not an XSUB" );
   if (!(SvROK(true_val) && SvOBJECT(SvRV(true_val)) && SvIOK(SvRV(true_val))))
      croak( "_true_value is not a boolean reference" );
   if (!(SvROK(false_val) && SvOBJECT(SvRV(false_val)) && SvIOK(SvRV(false_val))))
      croak( "_false_value is not a boolean reference" );

   encode_xsub = CvXSUB(encode_cv);
   decode_xsub = CvXSUB(decode_cv);
   CvXSUB(encode_cv) = XS_Polymake__BSONbooleanAdapter__encode_bson;
   CvXSUB(decode_cv) = XS_Polymake__BSONbooleanAdapter__decode_bson;
   true_sv = true_val;
   false_sv = false_val;

   // assume for now we don't have other magic hashes in serialized form
   Tie_IxHash_stash = pm::perl::glue::get_named_stash(aTHX_ "Tie::IxHash");
   BSON_Doc_stash = gv_stashpvn("BSON::Doc", 9, 0);
   if (!BSON_Doc_stash) // is absent in older Mongo drivers: make a dummy address matching nothing
      BSON_Doc_stash = Tie_IxHash_stash+1;
}
#line 369 "/builddir/build/BUILD/polymake-4.4/build.i386/perlx/5.34.0/i386-linux-thread-multi-64int/BSONbooleanAdapter.cc"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Polymake__BSONbooleanAdapter_prepare_PP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Polymake__BSONbooleanAdapter_prepare_PP)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "encode_subref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	encode_subref = ST(0)
;
#line 168 "/builddir/build/BUILD/polymake-4.4/lib/core/src/perl/BSONbooleanAdapter.xxs"
{
   if (encode_cv)
      croak( "BSONbooleanAdapter::prepare called repeatedly - should only be invoked from the static part of its perl module" );
   if (!(SvROK(encode_subref) && SvTYPE(SvRV(encode_subref)) == SVt_PVCV &&
         (encode_cv = (CV*)SvRV(encode_subref), !CvISXSUB(encode_cv) && CvROOT(encode_cv))))
      croak( "_encode_bson is not a regular SUB" );
   boolean_pkg = newSVpvn_share("boolean", 7, 0);
   replace_ref(aTHX_ CvROOT(encode_cv));
}
#line 397 "/builddir/build/BUILD/polymake-4.4/build.i386/perlx/5.34.0/i386-linux-thread-multi-64int/BSONbooleanAdapter.cc"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Polymake__BSONbooleanAdapter); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Polymake__BSONbooleanAdapter)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Polymake::BSONbooleanAdapter::_encode_bson", XS_Polymake__BSONbooleanAdapter__encode_bson);
        newXS_deffile("Polymake::BSONbooleanAdapter::_decode_bson", XS_Polymake__BSONbooleanAdapter__decode_bson);
        newXS_deffile("Polymake::BSONbooleanAdapter::prepare_XS", XS_Polymake__BSONbooleanAdapter_prepare_XS);
        newXS_deffile("Polymake::BSONbooleanAdapter::prepare_PP", XS_Polymake__BSONbooleanAdapter_prepare_PP);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

